import std;

backend web1 {
  .host = "127.0.0.1";
  .port = "8080";
  .first_byte_timeout = 18000s;
  .between_bytes_timeout = 18000s;
}

#backend web1 { .host = "10.33.180.243"; .port = "8080"; .between_bytes_timeout = 60s; .connect_timeout = 60s; .first_byte_timeout = 60s; .probe = { .url = "/healthcheck"; .interval = 3s; .timeout = 1s; .window = 5;.threshold = 3; }}
#backend web2 { .host = "10.39.71.120"; .port = "8080"; .between_bytes_timeout = 60s; .connect_timeout = 60s; .first_byte_timeout = 60s; .probe = { .url = "/healthcheck"; .interval = 3s; .timeout = 1s; .window = 5;.threshold = 3; }}

#director mgt round-robin {
# {
#     .backend = web1;
# }
# {
#     .backend = web2;
# }
#}

sub vcl_recv {
    if (req.restarts == 0) {
        if (!req.http.x-forwarded-for) {
           set req.http.X-Forwarded-For = client.ip;
        }
    }

    #set req.backend = mgt;
    return (pass);

    if (req.url ~ "/healthcheck"){
        error 200 "ok";
        set req.http.Connection = "close";
    }

    if (req.request == "PURGE") {
        if (req.http.X-Magento-Tags-Pattern) {
            ban("obj.http.X-Magento-Tags ~ " + req.http.X-Magento-Tags-Pattern);
            error 200 "Purged";
        } else {
          ban("req.http.host == " +req.http.host+" && req.url ~ "+req.url);
          error 200 "Purged";
        }
    }

    if (req.request != "GET" &&
        req.request != "HEAD" &&
        req.request != "PUT" &&
        req.request != "POST" &&
        req.request != "TRACE" &&
        req.request != "OPTIONS" &&
        req.request != "DELETE") {
          /* Non-RFC2616 or CONNECT which is weird. */
          return (pipe);
    }

    # We only deal with GET and HEAD by default
    if (req.request != "GET" && req.request != "HEAD") {
        return (pass);
    }

    # normalize url in case of leading HTTP scheme and domain
    set req.url = regsub(req.url, "^http[s]?://", "");

    # collect all cookies
    std.collect(req.http.Cookie);

    if (req.url ~ "t.php") {
       return (pass);
    }

    if (req.url ~ "^/blog/" ||
        req.url ~ "^/admin/" ||
        req.url ~ "^/mgtvarnish/" ||
        req.url ~ "/catalogsearch/" ||
        req.url ~ "/product_compare/" ||
        req.url ~ "/contact/" ||
        req.url ~ "/customer/" ||
        req.url ~ "/downloadable/" ||
        req.url ~ "/sales/" ||
        req.url ~ "/vault/" ||
        req.url ~ "/newsletter/" ||
        req.url ~ "/vault/" ||
        req.url ~ "/review/" ||
        req.url ~ "/wishlist/" ||
        req.url ~ "/checkout/" ||
        req.url ~ "/adyen/" ||
        req.url ~ "/paypal/") {
        return (pass);
    }

    # normalize Aceept-Encoding header
    # http://varnish.projects.linpro.no/wiki/FAQ/Compression
    if (req.http.Accept-Encoding) {
        if (req.url ~ "\.(jpg|png|gif|gz|tgz|bz2|tbz|mp3|ogg|swf|flv)$") {
            # No point in compressing these
            remove req.http.Accept-Encoding;
        } elsif (req.http.Accept-Encoding ~ "gzip") {
            set req.http.Accept-Encoding = "gzip";
        } elsif (req.http.Accept-Encoding ~ "deflate" && req.http.user-agent !~ "MSIE") {
            set req.http.Accept-Encoding = "deflate";
        } else {
            # unkown algorithm
            remove req.http.Accept-Encoding;
        }
    }

    # remove Google gclid parameters
    set req.url = regsuball(req.url,"\?gclid=[^&]+$",""); # strips when QS = "?gclid=AAA"
    set req.url = regsuball(req.url,"\?gclid=[^&]+&","?"); # strips when QS = "?gclid=AAA&foo=bar"
    set req.url = regsuball(req.url,"&gclid=[^&]+",""); # strips when QS = "?foo=bar&gclid=AAA" or QS = "?foo=bar&gclid=AAA&bar=baz"

    return (lookup);
}

sub vcl_hash {
    if (req.http.cookie ~ "X-Magento-Vary=") {
        hash_data(regsub(req.http.cookie, "^.*?X-Magento-Vary=([^;]+);*.*$", "\1"));
    }
}

sub vcl_fetch {

    if (beresp.http.content-type ~ "text") {
        set beresp.do_esi = true;
    }

    if (req.url ~ "\.js$" || beresp.http.content-type ~ "text") {
        set beresp.do_gzip = true;
    }

    # cache only successfully responses and 404s
    if (beresp.status != 200) {
        set beresp.ttl = 0s;
        return (hit_for_pass);
    } elsif (beresp.http.Cache-Control ~ "private") {
        return (hit_for_pass);
    }

    if (beresp.http.X-Magento-Debug) {
        set beresp.http.X-Magento-Cache-Control = beresp.http.Cache-Control;
    }

    # validate if we need to cache it and prevent from setting cookie
    # images, css and js are cacheable by default so we have to remove cookie also
    if (beresp.ttl > 0s && (req.request == "GET" || req.request == "HEAD")) {
        unset beresp.http.set-cookie;
            if (req.url !~ "\.(ico|css|js|jpg|jpeg|png|gif|tiff|bmp|mp3|ogg|svg|swf|woff|woff2|eot|ttf|otf)(\?|$)") {
            set beresp.http.Pragma = "no-cache";
            set beresp.http.Expires = "-1";
            set beresp.http.Cache-Control = "no-store, no-cache, must-revalidate, max-age=0";
            set beresp.grace = 1m;
        }
    }
}

sub vcl_deliver {

    set resp.http.X-Cache-Age = resp.http.Age;

    if (!resp.http.X-Cache-Debug) {
        unset resp.http.X-Magento-Tags;
        unset resp.http.X-Magento-Route;
    }

    unset resp.http.Age;
    unset resp.http.X-Cache-Debug;
    unset resp.http.X-Magento-Debug;
    unset resp.http.X-Powered-By;
    unset resp.http.Server;
    unset resp.http.X-Varnish;
    unset resp.http.Via;
    unset resp.http.Link;
}

